# Document.pm

package Document;

use vars qw($DOC_DIR);

$DOC_DIR	 = "/var/tmp";

sub new {
    my $pkg	 = shift or die "Error: constructor requires OO syntax";
    my $self	 = {
	'name'	 => "",
	'text'	 => "",
    };
    return bless $self, $pkg;
}

sub text {
    die "Error: parameter missing" if @_ < 1;
    my ($self, $newval)	 = @_;
    if (defined $newval) {
	$self->{'text'}	 = $newval;
    }
    return $self->{'text'};
}

sub typeset {
    die "Error: parameter missing" if @_ < 1;
    my $self	 = shift;
    my $name	 = $self->{'name'} || "texdoc-$$";
    my $texfile	 = "$DOC_DIR/$name.tex";

    open TEXFILE, "> $texfile"
      or die "Error: could not open $texfile for writing: $!";
    print TEXFILE $self->tex;
    close TEXFILE;

    $ENV{'PATH'}	 .= ":/usr/local/teTeX/bin/i686-pc-linux-gnu:";
    my $redir	 = " > $name.out 2>&1 < /dev/null";
    my $error	 = system "(cd $DOC_DIR && pdftex $name $redir)";
    if ($error) {
	die "Error: pdftex returned exit status of: " . ($error / 256);
    }

    return $self->slirp_file("$DOC_DIR/$name.pdf");
}

sub tex {
    die "Error: parameter missing" if @_ < 1;
    my ($self)	 = @_;
    my $tex	 = "\% Produced by a Document\n";
    $tex	 .= $self->{'text'};
    $tex	 .= "\\bye";

    return $tex;
}

sub slirp_file {
    die "Error: parameter missing" if @_ < 2;
    my ($self, $filename)	 = @_;
    my $contents;
    {
	local $/;
	undef $/;
	open IN, $filename
	  or die "Error: could not open $filename for reading";
	$contents	 = <IN>;
	close IN;
    }
    return $contents;
}

