#! /usr/bin/perl -w

use strict;
use CGI;
use CGI::Carp;
use Letter;

use vars qw($TMP_DIR);
$TMP_DIR	 = "/var/tmp";

&do_something(new CGI());

sub do_something {
    die "Error: missing parameter" if @_ < 1;
    my $cgih	 = shift;

    if ($cgih->param()) {
	&print_feedback_page($cgih);
    } else {
	&print_welcome_page($cgih);
    }
}

sub print_welcome_page {
    die "Error: missing parameter" if @_ < 1;
    my $cgih	 = shift;

    print $cgih->header;
    print $cgih->start_html(-title => "webletter -- Welcome");

    # -- stick the name of the document onto the "action"
    # -- attribute of the form HTML tag
    my $action
      = $cgih->url(-relative	 => "yes") . "/product.pdf";
    print $cgih->startform(-action => $action);

    foreach my $part ("Sender", "Recipient", "Text") {
	print "<p>$part:<br>\n";
	print $cgih->textarea(-name	 => lc($part),
			      -wrap	 => "hard",
			      -rows	 => 5);
	print "\n";
    }
    print $cgih->submit(-name	 => "action",
			-value	 => " make me a form ") . "\n";
    print $cgih->endform() . "\n";
    print $cgih->end_html;
}

sub print_feedback_page {
    die "Error: missing parameter" if @_ < 1;
    my $cgih	 = shift;
    my $letter	 = new Letter();
    $letter->sender($cgih->param("sender") or die "no sender");
    $letter->recipient($cgih->param("recipient")
		       or die "no recipient");
    $letter->text($cgih->param("text") or die "no text");
    my $pdf	 = $letter->typeset;

    print $cgih->header(-type	 => "application/pdf");
    print $pdf;
}
