# Letter.pm

package Letter;
use Document;

@ISA	 = qw(Document);

sub new {
    my $pkg	 = shift
      or die "Error: constructor requires OO syntax";
    my $self	 = new Document;

    # recipient, sender

    return bless $self, $pkg;
}

sub recipient {
    die "Error: parameter missing" if @_ < 1;
    my ($self, $newval)	 = @_;
    if (defined $newval) {
	$self->{'recipient'}	 = $newval;
    }
    return $self->{'recipient'};
}

sub sender {
    die "Error: parameter missing" if @_ < 1;
    my ($self, $newval)	 = @_;
    if (defined $newval) {
	$self->{'sender'}	 = $newval;
    }
    return $self->{'sender'};
}

sub tex {
    die "Error: parameter missing" if @_ < 1;
    my ($self)	 = @_;
    my $vspace
      = '\null\vskip 1cm plus .5cm minus .75cm' . "\n";
    my $header	 = <<'END_OF_HEADER';
% Produced by a Letter
\font\bigfont=cmssbx10 at 16 pt
\font\twelverm=cmr12

% impress people with a fancy summation
\hfil {\bigfont FANCY SUMMATIONS, INC.}
\hfil $$\sum_{n=0}^\infty2y+4x^2$$\hfill

\nopagenumbers
\advance\baselineskip by 1ex
\twelverm

END_OF_HEADER

    my $tex	 = $header . $vspace;
    $tex	 .= "{\\obeylines\n" . `date` . $self->sender;
    $tex	 .= "\n$vspace\n" . $self->recipient
      . "}\n$vspace\n";
    $tex	 .= $self->{'text'};
    $tex	 .= "\\bye";

    return $tex;
}
