#! /usr/bin/perl -w

use strict;

my $entriesR	 = &parse_group_file("/etc/group");
foreach my $entryR (@$entriesR) {
    printf("groupname: %10s\tmembers: %s\n",
	   $entryR->[0],
	   $entryR->[1]);
}

sub parse_group_file {
    die "Error: missing parameter" if @_ < 1;
    my $groupfile	 = shift;
    my @entries;

    open GROUPFILE, $groupfile
      or die "Error: could not open $groupfile: $!";
    while (defined(my $line = <GROUPFILE>)) {
	my ($groupname, $members) = ($line =~ /(.*?):.*?:.*?:(.*)/);
	push @entries, [ $groupname, $members ];
    }
    return \@entries;
}
